import java.io.IOException;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;


@WebServlet("/persistName")
public class PersistUtfServlet extends HttpServlet {
	@PersistenceContext(unitName="primary") 
	EntityManager em;
	
	@Resource 
	private UserTransaction utx;
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		request.setCharacterEncoding("UTF-8");
		
		String name = request.getParameter("name");
		Long id = new Long(request.getParameter("id"));
		
		UnicodeModel model = new UnicodeModel();
		model.setId(id);
		model.setVal(name);
		
		System.out.println("preparing to persist new model [" + model + "]");
		
		try {
			utx.begin();
			em.persist(model);
			utx.commit();
			System.out.println("successfully persisted new model [" + model + "]");
		} catch (Exception e) {
			try {
				System.out.println("failed to persist new model [" + model + "]");
				e.printStackTrace();
				utx.rollback();
			} catch (Exception ue) {
				ue.printStackTrace();
			}
		}		
	}
}
